;=======================================================================
;   Combined string v 4.0 Unicode   
;=======================================================================
macro CSNew _size { ;        !!!!!!!
;-----------------------------------------------------------------------
    push edi        ;  
    push esi
    mov esi,esp     ;  
    sub esp,_size
    mov edi,esp     ;  
    push esi        ;  -   
;-----------------------------------------------------------------------
}
;=======================================================================
macro CSEnd {       ;      
;-----------------------------------------------------------------------
    mov word [edi],0
;-----------------------------------------------------------------------
}
;=======================================================================
macro CSFree {      ;     
;-----------------------------------------------------------------------
    pop esp
    pop esi
    pop edi
;-----------------------------------------------------------------------
}    
;=======================================================================
macro CSAdd [_str] { ;       ()
;-----------------------------------------------------------------------
    local ..more
;-----------------------------------------------------------------------
    if ~(_str eq)
        mov esi,_str
    end if
..more:
    cmp word [esi],0
    movsw
    jne ..more
    dec edi
    dec edi
;-----------------------------------------------------------------------
}
;=======================================================================
macro CSAddQS _str { ; eg. PathQuoteSpaces
;-----------------------------------------------------------------------
    if ~(_str eq)
        mov esi,_str
    end if
;-----------------------------------------------------------------------
    call add_qs
;-----------------------------------------------------------------------
}
;=======================================================================
macro CSQuoteSpaces _start { ; eg. PathQuoteSpaces
;-----------------------------------------------------------------------
    if ~(_start eq)
        mov edx,_start
    end if
;-----------------------------------------------------------------------
    call edx_edi_qs
;-----------------------------------------------------------------------
}
;=======================================================================
macro CSAddChar [_char] { ;      ()
;-----------------------------------------------------------------------
    mov word [edi],_char
    inc edi
    inc edi
;-----------------------------------------------------------------------
}
;=======================================================================
macro CSAddCR { ;        
;-----------------------------------------------------------------------
    mov dword [edi],0A000Dh
    add edi,4
;-----------------------------------------------------------------------
}
;=======================================================================
macro CSAddDec _param {  ;       
                         ;   (  ) 
;-----------------------------------------------------------------------
    local ..next
;-----------------------------------------------------------------------
    if ~(_param eq)
      mov eax,_param
    end if
;-----------------------------------------------------------------------
    call eax_edi_dec
;-----------------------------------------------------------------------
}
;=======================================================================
macro CSAddHex _param {  ;       
                         ;    (  ) 
;-----------------------------------------------------------------------
    local ..next,..dcm
;-----------------------------------------------------------------------
    if ~(_param eq)
      mov eax,_param
    end if
;-----------------------------------------------------------------------
    call eax_edi_hex
;-----------------------------------------------------------------------
}
;=======================================================================
macro CSAddSign _param { ;     -  ,
                         ;   ,     "-"
;-----------------------------------------------------------------------
    local ..next
;-----------------------------------------------------------------------
    if ~(_param eq)
      mov eax,_param
    end if
;-----------------------------------------------------------------------
    cmp eax,0
    jns ..next
    neg eax
    mov word [edi],"-"
    inc edi
    inc edi
..next:
;-----------------------------------------------------------------------
}
;=======================================================================
macro CSAddSignX _param { ;     ("+"  "-")
                          ;  "-" -  
;-----------------------------------------------------------------------
    local ..next
;-----------------------------------------------------------------------
    if ~(_param eq)
      mov eax,_param
    end if
;-----------------------------------------------------------------------
    mov cx,"+"
    cmp eax,0
    jns ..next
    neg eax
    mov cx,"-"
..next:
    mov [edi],cx
    inc edi
    inc edi
;-----------------------------------------------------------------------
}
;=======================================================================
macro CSLMessage _hWnd {    ;    :)
                            ;     
;-----------------------------------------------------------------------
    CSEnd
    lea ecx,[esp + 4]
if _hWnd eq    
    invoke MessageBox,0,ecx,0,0
else
    invoke MessageBox,_hWnd,ecx,0,0
end if    
    CSFree
;-----------------------------------------------------------------------
}
;=======================================================================
macro CSLoad _addr  { ;  
;-----------------------------------------------------------------------
    push edi
    push esi
    mov  edi,_addr
;-----------------------------------------------------------------------
}
;=======================================================================
macro CSRestore     { ;  
;-----------------------------------------------------------------------
    pop esi
    pop edi
;-----------------------------------------------------------------------
}        
;=======================================================================
;
;=======================================================================
macro UCSSupport { ;  -    
;-----------------------------------------------------------------------
if ~ defined UCSSupportUsed
             UCSSupportUsed equ 1
;-----------------------------------------------------------------------
proc eax_edi_dec ;    UCSAddDec
;-----------------------------------------------------------------------
    mov esi,esp
    sub esp,32
    xor ecx,ecx
.next:
    dec esi
    dec esi
    xor edx,edx
    div dword [CSTen]
    add dl,"0"
    mov [esi],dx
    inc ecx
    test eax,eax
    jnz .next
    rep movsw
    add esp,32
;-----------------------------------------------------------------------
    ret
;-----------------------------------------------------------------------
endp    
;=======================================================================
proc eax_edi_hex ;    CSAddHex
;-----------------------------------------------------------------------
    mov esi,esp
    sub esp,32
    xor ecx,ecx
    xor edx,edx
.next:
    dec esi
    dec esi
    mov dl,al
    and dl,15
    cmp dl,9
    jbe .dcm
    add dl,7
.dcm:    
    add dl,"0"
    mov [esi],dx
    inc ecx
    shr eax,4
    jnz .next
    rep movsw
    add esp,32
;-----------------------------------------------------------------------
    ret
;-----------------------------------------------------------------------
endp
;=======================================================================
proc add_qs
;-----------------------------------------------------------------------
    xor ecx,ecx
    mov edx,esi
.next:
    cmp word [esi]," "
    je  .quot
    cmp word [esi],0
    je  .copy
    inc esi
    inc esi
    jmp .next
;-----------------------------------------------------------------------
.quot:
    inc ecx
    mov word [edi],'"'
    inc edi
    inc edi
.copy:
    mov esi,edx    
;-----------------------------------------------------------------------
.more:
    cmp word [esi],0
    movsw
    jne .more
    dec edi
    dec edi
;-----------------------------------------------------------------------
    mov word [edi],'"'
    jecxz .done   
    inc edi
    inc edi
.done:
    ret
;-----------------------------------------------------------------------
endp
;=======================================================================
proc edx_edi_qs
;-----------------------------------------------------------------------
    cmp edi,edx
    je  .done
    std
    mov esi,edi
    mov eax,20h
    mov ecx,edi
    sub ecx,edx
    shr ecx,1
    dec edi
    mov edx,ecx
    repne scasw
    mov edi,esi
    jne .done
    mov ecx,edx
    mov edx,esi
    dec esi
    dec esi
    rep movsw
    mov word [edi],'"'
    lea edi, [edx + 2]
    mov word [edi],'"'
    inc edi
    inc edi
.done:
    cld
    ret    
;-----------------------------------------------------------------------
endp
;=======================================================================
CSTen:        dd 10 ;   UCSAddDec
;=======================================================================
proc NumToDecU num,pstr,sign
;-----------------------------------------------------------------------
    CSLoad [pstr]
    mov eax,[num]
    cmp [sign],0
    je  @F
    CSAddSign
@@:
    CSAddDec
    CSEnd
    CSRestore
    ret    
;-----------------------------------------------------------------------
endp
;-----------------------------------------------------------------------
end if
}
;=======================================================================
                




                       